/*--------------*
 |   textpack	|-*			Copyright (c) 1990-1999 by Altair
 | Version 2.11 | |					All rights reserved.
 *--------------* |
   *--------------*	This file contains some comments in Japanese language
			with the Shift_JIS code.
How to compile...

Linux:	gcc -O2 -s -lm -otextpack textpack.c

OS/2:	chcp 437
	gcc -O2 -s -Zomf -Zsmall-conv textpack.c
	lxlite textpack.exe

DOS:	bcc -O2 -a -d -1 -ms textpack.c
	lzexe textpack
======================================================
 Ver.	    ŗ
------------------------------------------------------
 2.00	2xڂ̑Sʉ
 2.01	Bug fix: sɑSp󔒂ƁAꂪc
	Bug fix: Ctrl-Z1s邱Ƃ
 2.02	rCtrl-Zȍ
	ꕔweb browser(-rw)p~
	̕LF̏ǉ
	Greeting messagee-mail addressύX
 2.03	*.htmls*.htmlsdefaultǉ (DOSł)
 2.04	Target openɘÄmۂ݂
	DBCSʕ@ύX	(OS/2)
	chsize()  ftruncate() (DOSł)
	LinuxɑΉ		({ꖢΉ)
	ESC sequence̗p߂
	Salutehelpo͐stderrstdoutɕύX
	2.02Ŕp~-rwhelp messageɎcĂ
	Switch'-'݂̂ƂA'/'̗p߂
 2.05	ϐnw̐ݒlog10Zp֐̗p߂
 2.06	is󋵕\̕pxsPʂbPʂɕύX
	XCb`̉߂ɂ
 2.07	unistd.hinclude@ύX (Linuxł̂)
 2.08	^[QbgEN[Ys̃bZ[WC
	e푮IWi^[QbgɃRs[
	2.04Œǉ̈mۂ݂̎p~
 2.09	OS/2gfBtHgł̓Z[uȂ
	-e (OS/2g̕ۑ)XCb`ǉ
 2.10	-pA-vA-VXCb`ǉ
	-eXCb`̏O@ύX (DOS)
	IvṼfBtHgl
	Linuxłłgq`FbN
	A[Mg̏ꍇAwv\
	root[UɃp[~VmFȂ (Linux)
 2.11	gq_uĕ\Ă܂oOC
=====================================================*/
#define VERSION		"2.11\t"

#ifdef __MSDOS__
# define REPORT_PERIOD	15 /* tick */
#else
# define REPORT_PERIOD	 1 /* sec */
#endif

#ifdef __EMX__
# define INCL_DOSNLS
# include <os2.h>
# include <sys/nls.h>
# define iskana(c)	((c)>=0xA1&&(c)<=0xDF)
#endif

#include <sys/types.h>
#include <sys/stat.h>

#ifdef unix
# include <dirent.h>
#else
# include <io.h>
# include <fcntl.h>
# include <process.h>
#endif

#ifdef __MSDOS__
# include <dos.h>
# include <dosv.h>
# include <jctype.h>
# define _nls_is_dbcs_lead(x)	iskanji(x)
# define ftruncate(handle,size) chsize(handle,size)
#else
# include <signal.h>
#endif

#include <utime.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef unix
#define strnicmp	strncasecmp
#endif
#include <errno.h>
#include <math.h>

typedef unsigned char byte;

#define FALSE	    0
#define TRUE	    1
#define MAX_BUFF 8192
#define SPECIAL	  '\r'

#ifndef	 EXIT_SUCCESS
# define EXIT_SUCCESS 0
# define EXIT_FAILURE 1
#endif

#ifdef unix
# include <unistd.h>
# define dos2(x)

# ifndef SIG_ACK
#  define SIG_ACK alarm_handler
# endif

enum crlf{NO_CR,AUTO_CR,ALWAYS_CR}crlf=NO_CR;
char target_name[MAXNAMLEN];

typedef struct{
  byte in_quate:1,
       keepdate:1,
       in_pre:1;
}FLAGS;

struct{
  byte in_quate:1,
       keepdate:1,
       in_pre:1;
}dft={
    TRUE,   /* in_quate */
    TRUE,   /* keepdate */
    TRUE    /* in_pre	*/
};
#else
# define dos2(x) x

enum crlf{NO_CR,AUTO_CR,ALWAYS_CR}crlf;
int keepea=FALSE;
byte lkj;

typedef struct{
  byte in_quate:1,
       keepdate:1,
       in_pre:1;
  enum crlf crlf;
}FLAGS;

struct{
  byte in_quate:1,
       keepdate:1,
       in_pre:1,
       crlf:1;
}dft={
    TRUE,   /* in_quate */
    TRUE,   /* keepdate */
    TRUE,   /* in_pre	*/
    TRUE    /* crlf	*/
};
char target_name[L_tmpnam],ea_name[L_tmpnam];
# ifdef __MSDOS__
int lastdrive;
# endif
#endif

volatile int alarmf;
FILE*source,*target;
struct stat st;
float oldsz;
long tpos;
int in_quate,keepdate,in_pre,dbcs,pre,verbose=FALSE;
unsigned char space;
byte dash=FALSE,stab=8,ttab=8,nw;

static void disp_size(){
  fprintf(stderr,"New size (tab=%hi):%*li (%.1f%%)\r",ttab,nw,tpos,tpos*oldsz);
}

#ifdef __MSDOS__
static void interrupt timer_tick_handler(){
#else
#ifdef __EMX__
static void alarm_handler(){
#else
static void alarm_handler(int sig){
#endif
  signal(SIGALRM,SIG_ACK);
#endif
  ++alarmf;
}

#ifdef unix
#define salute() puts("\nAltair's textpack\tCopyright (c) 1990-1999 by Altair"\
		      "\n   Version "VERSION"\t\tNBG01720@nifty.ne.jp")
#else
static void salute(){
  char*cp;
#ifdef __EMX__
  COUNTRYCODE cc;
  UCHAR buffer[12];

  cc.country=cc.codepage=0;
  dbcs=DosQueryDBCSEnv(12,&cc,buffer)?FALSE:*(short*)buffer;
#else
  dbcs=dosvgetdosenv()&1;
#endif
  cp=dbcs?"":"";
  printf("\nAltair%s's textpack\tCopyright (c) 1990-1999 by Altair%s"
	 "\n   Version "VERSION"\t\tNBG01720@nifty.ne.jp\n",cp,cp);
}
#endif

#define E_USAGE		"\nUsage:\ttextpack  [options...]"		\
			"\tfilename(s)...\n\nOptions:\n  -h"
#define E_HELP1		"  = Display this command line help  -d-"	\
			"\t    = Update time stump\n"			\
			"  --\t  = '-' as usual filename"		\
			"\t    -d\t    = Keep time stump\n"		\
			"  -v\t  = Verbose options"			\
			"\t\t    -V\t    = Show version\n"		\
			"  -s{4|8} = Source tab size (default=8)"	\
			"\t    -t{4|8} = Dest. tab (default=8)\n"	\
			"  -r+\t  = Put CR and LF to each line"		\
			"\t    -t0\t    = No tabs after packing\n"	\
			"  -r-\t  = Put LF w/o CR (default)"
#ifndef unix
# define E_EA		"\t    -e\t    = Keep extended attributes"
#endif
#define E_HELP2		"\n  -r\t  = Put only LF to empty lines "	\
			"and put CR and LF to the others\n"		\
			"  -p\t  = Convert from spaces to tab "		\
			"between <pre> and </pre>\n"			\
			"  -p-\t  = Don't convert from spaces to tab "	\
			"between <pre> and </pre>\n"			\
			"  -q\t  = Convert from spaces to tab "		\
			"between the quatations\n"			\
			"  -q-\t  = Don't convert from spaces to tab "	\
			"between the quatations\n\n"
#ifdef unix
# define E_DFT		"Defaults:  *.txt *.doc *.lst *.list:"		\
			" -d\t -q  -p-\n"				\
			"       *.htm *.html *.htmls *.shtml:"		\
			" -d- -q  -p\n"					\
			"\t      when `-p' is spcified: -d- -q\n"	\
			"\t\t\t     Others: -d\t -q- -p-"
#else
# ifdef __MSDOS__
#  define E_DFT		"Default:   *.bat *.cmd: -r+ -d\t-q- -p-\n"	\
			"\t\t *.htm: -r- -d- -q  -p\n"			\
			"     *.txt *.doc *.lst: -r  -d\t-q  -p-\n"	\
			" when `-p' is spcified: -r- -d- -q\n"		\
			"\t\tOthers: -r  -d\t-q- -p-"
# else
#  define E_DFT		"Default:\t   *.bat *.cmd: -r+ -d\t-q- -p-\n"	\
			"  *.htm *.html *.htmls *.shtml: -r- -d- -q  -p"\
			"\n      *.txt *.doc *.lst *.list:"		\
			" -r  -d\t-q  -p-\n"				\
			"\ttwhen `-p' is spcified: -r- -d- -q\n"	\
			"\t\t\tOthers: -r  -d\t-q- -p-"
# endif
# define J_USAGE	"\ng:\t textpack  [IvV...]  "	\
			"t@C...\n\nIvV:\n  -h"
# define J_HELP1	"  = wvbZ[W̕\\"			\
			"\t   -d-\t   = Ƀt@CXV\n"	\
			"  --\t  = t@C̐擪'-'e"		\
			"\t   -d\t   = Õt@Cێ\n"	\
			"  -v\t  = IvV\\"		\
			"\t   -V\t   = o[W\\ďI\n"	\
			"  -s{4|8} = eLXg̃^u (default:8)"	\
			"   -t{4|8} = ̃^u (default:8)\n"	\
			"  -r+\t  = SĂ̍sCR LFŏI["		\
			"\t   -t0\t   = ^uSċ󔒕ɒu\n"	\
			"  -r-\t  = SĂ̍sLF݂̂ł̏I["
# define J_EA		"\t   -e\t   = OS/2gۑ"
# define J_HELP2	"\n  -r\t  = sLF̂݁B"			\
			"ȊO̍sCR LFŏI[\n"			\
			"  -p\t  = <pre></pre>ɋ܂ꂽ񒆂"	\
			"󔒕A^u֒u\n"		\
			"  -p-\t  = <pre></pre>ɋ܂ꂽ񒆂"	\
			"󔒕́A^u֒uȂ\n"		\
			"  -q\t  = pɋ܂ꂽ񒆂"		\
			"󔒕A^u֒u\n"		\
			"  -q-\t  = pɋ܂ꂽ񒆂"		\
			"󔒕́A^u֒uȂ\n\n"
# ifdef __MSDOS__
#  define J_DFT		"fBtHg:  *.bat *.cmd: -r+ -d  -q- -p-\n" \
			"\t\t     *.htm: -r- -d- -q\t-p\n"		\
			"\t *.txt *.doc *.lst: -r\t-d  -q\t-p-\n"	\
			"\t-pw肳ꂽꍇ: -r- -d- -q\n"		\
			"\t\t    ̑: -r\t-d  -q- -p-"
# else
#  define J_DFT		"fBtHg:\t   *.bat *.cmd: -r+ -d\t-q- -p-"\
			"\n  *.htm *.html *.htmls *.shtml:"		\
			" -r- -d- -q  -p\n"				\
			"      *.txt *.doc *.lst *.list:"		\
			" -r  -d\t-q  -p-\n"				\
			"\t    -pw肳ꂽꍇ: -r- -d- -q\n"	\
			"\t\t\t̑: -r  -d\t-q- -p-"
# endif
#endif

static void help(){
#ifdef unix
  salute();
  puts(E_USAGE "\t" E_HELP1 E_HELP2 E_DFT);
#endif
#ifdef __EMX__
  puts(dbcs?J_USAGE "\t" J_HELP1 J_EA J_HELP2 J_DFT
	   :E_USAGE "\t" E_HELP1 E_EA E_HELP2 E_DFT);
#endif
#ifdef __MSDOS__
  char*format,*ea;

  if(dbcs){
    format=J_USAGE ", /?" J_HELP1 "%s" J_HELP2 J_DFT;
    ea=J_EA;
  }else{
    format=E_USAGE ", /?" E_HELP1 "%s" E_HELP2 E_DFT;
    ea=E_EA;
  }
  printf(format,_osmajor==20?ea:"");
#endif
  exit(EXIT_SUCCESS);
}
static void badval(const char*arg){
  fprintf(stderr,"\nArgument \"%s\" is invalid for \"-%c\" switch\n",
	  arg+1,*arg);
  exit(EXIT_FAILURE);
}
static int gettabopt(const char*arg){
  switch(arg[1]){
    case 0:  fprintf(stderr,"\nArgument required for \"-%c\" switch\n",*arg);
	     exit(EXIT_FAILURE);

    case'0': if(*arg!='s')
    case'4':
    case'8':   if(!arg[2])
		 return arg[1]-'0';
  }
  badval(arg);
}
static int getmpo(const char*arg){
  int rc=FALSE;

  switch(arg[1]){
   case 0:  return TRUE;

   case'+': rc=TRUE;
   case'-': if(arg[2])
   default:   badval(arg);
  }
  return rc;
}
static void _getopt(const char*arg){
  switch(*(arg)){
    case's': stab=gettabopt(arg);  return;
    case't': ttab=gettabopt(arg);  return;

    case'q': in_quate=getmpo(arg); dos2(dft.in_quate=FALSE); return;
    case'd': keepdate=getmpo(arg); dos2(dft.keepdate=FALSE); return;

    case'V':
#ifdef unix
	     salute();
#endif
	     exit(EXIT_SUCCESS);

    case'p': in_pre=getmpo(arg);
	     dos2(dft.in_pre=FALSE);
	     if(in_pre){
	       if(dft.in_quate){ in_quate=TRUE;	 dos2(dft.in_quate=FALSE); }
	       if(dft.keepdate){ keepdate=FALSE; dos2(dft.keepdate=FALSE); }
#ifndef unix
	       if(dft.crlf)    { crlf=ALWAYS_CR;      dft.crlf=	   NO_CR;  }
#endif
	     }
	     return;

    case'v': if(arg[1])
	       badval(arg);
	     verbose=TRUE;
	     return;

    case'-': if(arg[1]) /*g--hXCb`ɂɖڂČ㑱镶 */
	       break;	/* ΁AXCb`w\̌ƌȂ  */

	     dash=TRUE;
	     return;

    case'r': dos2(dft.crlf=FALSE);
	     crlf=ALWAYS_CR;
	     switch(arg[1]){
	       case 0:	crlf=AUTO_CR;
			return;

	       case'-': crlf=NO_CR;
	       case'+':	  if(arg[2])
	       default:	    badval(arg);
	     }
	     return;

#ifndef unix
    case'e':
# ifdef __MSDOS__
	     if(_osmajor==20)	/* OS/2Ȃc */
# endif
	     { keepea=TRUE;
	       return;
	     }
#endif
  }
  help();
}

# define _d(v)	if(dft.v)v=defaults->v

static void setdefaults(const FLAGS*defaults){
  _d(in_quate); _d(keepdate); _d(in_pre); dos2(_d(crlf));
}

#ifdef __MSDOS__
# define LIST
# define HTML
#else
# define LIST	".list",
# define HTML	".html",".htmls",".shtml",
#endif

static void makedefaults(const char*ext){
#ifndef unix
  static char*bat[] ={".bat",".cmd",NULL};
#endif
  static char*txt[] ={".txt",".doc","lst",LIST NULL},
	     *html[]={".htm",HTML NULL};
#ifdef unix
  const FLAGS defaults[]={
    /*	 -q,	-d,    -p */
    {  TRUE,  TRUE, FALSE },	/* txt	  */
    {  TRUE, FALSE,  TRUE }	/* html	  */
  };
  const FLAGS others={
      FALSE,  TRUE, FALSE	/* others */
  };
#else
  const FLAGS defaults[]={
  /*	 -q,	-d,    -p,     -r */
    { FALSE,  TRUE, FALSE, ALWAYS_CR }, /* bat	  */
    {  TRUE,  TRUE, FALSE,   AUTO_CR }, /* txt	  */
    {  TRUE, FALSE,  TRUE,     NO_CR }	/* html	  */
  };
  const FLAGS others={
      FALSE,  TRUE, FALSE,   AUTO_CR	/* others */
  };
#endif
  char**exts[]={
#ifndef unix
    bat,
#endif
    txt,
    html,
    NULL
  };
  char**cpp;
  int i;
#ifdef unix			/* unixł				*/
# define stricmp strcmp		/* gq̑啶𓯈ꎋȂ */
  if(!ext)
    return;
#endif
  for(i=0;(cpp=exts[i])!=NULL;++i){
    for(;*cpp;++cpp)
      if(!stricmp(ext,*cpp)){
	setdefaults(defaults+i);
	return;
      }
  }
  setdefaults(&others);
}
#ifdef stricmp
# undef stricmp
#endif

#ifndef unix
static int chkname(const char*arg){
  char drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT],
       path[_MAX_PATH];

# ifdef __EMX__
  if(_fullpath(path,arg,_MAX_PATH))
# else
  if(!_fullpath(path,arg,_MAX_PATH))
# endif
    { fputs(" - Unable to obtain full path of this\n",stderr);
      return-1;
    }
  _splitpath(path,drive,dir,fname,ext);
# ifdef __EMX__
  _chdrive(*drive);
# else
  lastdrive=_getdrive();
  _chdrive((*drive|0x20)-'a'+1);
# endif
  makedefaults(ext);
  return 0;
}
#endif

#define isrw(mode) ((st.st_mode&(mode))==(mode))

static int chkperm(){
#ifdef unix
  if(!getuid()) /* root? */
    return 1;
  if(st.st_uid==getuid())
    if(isrw(S_IREAD|S_IWRITE))
      return 1;
  if(st.st_gid==getgid())
    if(isrw(S_IRGRP|S_IWGRP))
      return 1;
  if(isrw(S_IROTH|S_IWOTH))
    return 1;
  return 0;
#else
  return isrw(S_IREAD|S_IWRITE);
#endif
}

#define pm(x)	((x)?'+':'-')

static void showopt(void){
  char*r="";
  switch(crlf){
    case NO_CR:	    r="-"; break;
    case ALWAYS_CR: r="+";
  }
#ifdef unix
  fprintf(stderr,"\t-d%c -s%i -t%i -p%c -q%c -r%s\n",
	  pm(keepdate),stab,ttab,pm(in_pre),pm(in_quate),r);
#endif
#ifdef __EMX__
  fprintf(stderr,"\t-d%c -s%i -t%i -p%c -q%c -r%s -e%c\n",
	  pm(keepdate),stab,ttab,pm(in_pre),pm(in_quate),r,pm(keepea));
#endif
#ifdef __MSDOS__
  fprintf(stderr,"\t-d%c -s%i -t%i -p%c -q%c -r%s",
	  pm(keepdate),stab,ttab,pm(in_pre),pm(in_quate),r);
  if(_osmajor==20)	/* OS/2Ȃc */
    fprintf(stderr," -e%c",pm(keepea));
  fputc('\n',stderr);
#endif
}
static int openfiles(const char*name){
#ifndef unix
  if(keepea)
    spawnlp(P_WAIT,"eautil.exe","eautil.exe",name,tmpnam(ea_name),"/S","/P",
	    NULL);
#endif
  if(!(source=fopen(name,"rb")))
    perror(" - Can't open");
  else{
#ifdef unix
    sprintf(target_name,"%s.textpack",name);
#else
    tmpnam(target_name);
#endif
    if(fstat(fileno(source),&st)){
      fputs(" - ",stderr);
      perror(NULL);
    }else if(!st.st_size)
      fputs(" - Byte size is zero.  Do nothing\n",stderr);
    else if((st.st_mode&S_IFMT)!=S_IFREG)
      fputs(" - Not a regular file\n",stderr);
    else if(!chkperm())
      fputs(" - Permission denied\n",stderr);
    else if(!(target=fopen(target_name,"wb")))
      perror(" - Can't open work file");
    else{
#ifdef __BORLANDC__
      long tmp;
#else
      off_t tmp;
#endif
      if(verbose)
	showopt();
      fprintf(stderr,"\nOld size (tab=%hi): %li\n",stab,st.st_size);
      for(nw=1,tmp=st.st_size;tmp>0;++nw,tmp/=10);
      oldsz=100./st.st_size;
      return 0;
    }
    fclose(source);
#ifndef unix
    if(keepea)
      unlink(ea_name);
#endif
  }
  return-1;
}
static void bs(char*cp){
  short s,t;

  for(s=0;cp[s];++s)
    if(cp[s]=='\b'){
      if((t=s-1)<0)
	t=0;
      do{
	if(cp[++s]=='\b'){
	  if(--t<0)
	    t=0;
	}else
	  cp[t++]=cp[s];
      }while(cp[s]);
      return;
    }
}
static void detab(char*source,char*target){
  union{
    unsigned char*cp;
    unsigned short*sp;
  }s,t;
  char*lnsp,quate=0,bsl=FALSE;
  int spos=0;
  if(!pre)
    space=' ';
  dos2(lkj=FALSE);
  for(s.cp=source,t.cp=lnsp=target;;++s.cp)
#ifndef unix
    if(_nls_is_dbcs_lead(*s.cp)){
      if(!s.cp[1]){
	*t.cp=0;
	return;
      }
      if(*s.sp==0x4081/*Sp*/)
	*(t.sp++)=space*0x101;
      else{
	*(t.sp++)=*s.sp;
	lnsp=t.cp;
      }
      ++s.cp;
      spos+=2;
      bsl=FALSE;
      lkj=TRUE;
    }else
#endif
      {
	switch(*s.cp){
	  case' ':   *(t.cp++)=space;
		     ++spos;
		     break;

	  case'\t':  do
		       *(t.cp++)=space;
		     while(++spos&(stab-1));
	  case'\r':
	  case 0x1A: break;

	  case'\n':
	  case'\0':  *lnsp=0; return;

	  case'<':   if(in_pre){
		       if(!pre){
			 if(!strnicmp(s.cp+1,"pre",3))
			   pre=TRUE;
		       }else
			 if(!strnicmp(s.cp+1,"/pre",4))
			   pre=FALSE;
		       space=' ';
		     }
		     goto dtbdft;

	  case'>':   if(in_pre&&pre)
		       space=SPECIAL;
		     goto dtbdft;
	  case'\'':
	  case'"':   if(!in_quate&&!bsl){
		       if(!quate){
			 quate=*s.cp;
			 space=SPECIAL;
		       }else if(*s.cp==quate){
			 quate=0;
			 space=' ';
		       }
		     }
dtbdft:	  default:   *t.cp=*s.cp;
		     lnsp=++t.cp;
		     ++spos;
		     dos2(lkj=FALSE);
	}
	bsl=*s.cp=='\\'?!bsl:FALSE;
      }
}
static void entab(char*buf){
  char*cp;
  int i,j,k;

  if(!ttab){
    for(cp=buf;*cp;++cp)
      if(*cp==SPECIAL)
	*cp=' ';
    return;
  }
  k=strlen(buf);
  for(i=ttab-1;i<k;i+=ttab)
    if(buf[i]==' '){
      j=i-1;
      if(buf[j]==' '||buf[i+1]==' ')
	for(buf[i]='\t';j>=0;){
	  if(buf[j]==' ')
	    buf[j--]=0;
	  else
	    break;
	}
    }
  for(cp=buf,i=0;i<k;++i)
    if(buf[i])
      *(cp++)=buf[i]==SPECIAL?' ':buf[i];
  *cp=0;
}
#define NOERR	0
#define E_WRITE 1
#define E_READ	2
#define _e(x)	if((x)==EOF)return E_WRITE

static int _textpack(){
  char line0[MAX_BUFF],line1[MAX_BUFF];

  errno=pre=tpos=0;
  while(fgets(line0,MAX_BUFF,source)){
    bs(line0);
    detab(line0,line1);
    entab(line1);
    _e(fputs(line1,target));
    switch(crlf){
      case AUTO_CR:   if(!*line1)
			break;
      case ALWAYS_CR: _e(fputc('\r',target));
      default:	      ;
    }
    _e(fputc('\n',target));
    if(*line1/*słȂ*/)
      tpos=ftell(target);
    if(alarmf>=REPORT_PERIOD){
      disp_size();
      alarmf=0;
#ifndef __MSDOS__
      alarm(REPORT_PERIOD);
#endif
    }
  }
  rewind(target);
  ftruncate(fileno(target),tpos);
  return errno?E_READ:NOERR;
}

static void textpack(char*name){
  int i,j;
#ifdef __MSDOS__
  void interrupt(*org1Ch)();
#endif

  fprintf(stderr,"\n%s",name);

#ifdef unix
  makedefaults(strrchr(name,'.'));
#else
  if(chkname(name))
    return;
#endif
  if(openfiles(name))
    return;

  alarmf=REPORT_PERIOD;
#ifdef __MSDOS__
  org1Ch=getvect(0x1C);
  setvect(0x1C,timer_tick_handler);
  i=_textpack();
  setvect(0x1C,org1Ch);
#else
  signal(SIGALRM,alarm_handler);
  i=_textpack();
  signal(SIGALRM,SIG_IGN);
#endif
  disp_size();
  if(i){
    perror(i==E_WRITE?"\nwork file":"\noriginal file");
    fclose(source);
    fclose(target);
    remove(target_name);
  }else{
    fputs("\n",stderr);

    i=(fclose(source)==EOF);
    if(i)
      perror("Can't close original");
#ifdef unix
    fchmod(fileno(target),st.st_mode&07777);
    fchown(fileno(target),st.st_uid,st.st_gid);
#endif
    j=(fclose(target)==EOF);
    if(j)
      perror("Can't close target");

    if(!i&&!j){
      if(remove(name))
	perror("Can't remove original");
      else if(rename(target_name,name))
	perror("Can't rename work file");
      else{
	if(keepdate){
	  struct utimbuf ut;
	  ut.actime=st.st_atime;
	  ut.modtime=st.st_mtime;
	  utime(name,&ut);
	}
#ifndef unix
	if(keepea){
	  int nul,old_stderr=dup(2);
	  dup2(nul=open("nul",O_RDWR),2);
	  close(nul);
	  spawnlp(P_WAIT,"eautil.exe","eautil.exe",name,ea_name,"/J",NULL);
	  dup2(old_stderr,2);
	}
#endif
      }
    }
#ifdef __MSDOS__
    _chdrive(lastdrive);
#endif
  }
}
int main(int argc,char*argv[]){
  int i;

#ifdef __EMX__
  _response(&argc,&argv);
  _wildcard(&argc,&argv);
#endif
#ifndef unix
  salute();
#endif
  if(argc<=1)
    help();

  for(i=1;i<argc;++i)
    switch(*argv[i]){
#ifdef __MSDOS__
      case'/': if(argv[i][1]=='?')
		 help();
	       break;
#endif
      case'-': if(dash)
		 break;
	       *argv[i]=0;
	       _getopt(argv[i]+1);
    }
  for(i=1;i<argc;++i)
    if(*argv[i])
      textpack(argv[i]);

  return EXIT_SUCCESS;
}
